unit PKCmp;
{*****************************************************************
PKWARE Data Compression Library (R) for Win32
Copyright 1991,1992,1994,1995,1996 PKWARE Inc. All Rights Reserved
PKWARE Data Compression Library Reg. U.S. Pat. and Tm. Off.
******************************************************************}
interface

const
     CMP_BUFFER_SIZE = 36312;
     EXP_BUFFER_SIZE = 12596;

     CMP_DICT_SIZE1  = 1024;
     CMP_DICT_SIZE2  = 2048;
     CMP_DICT_SIZE3  = 4096;

     CMP_BINARY = 0;
     CMP_ASCII  = 1;

     CMP_NO_ERROR         = 0;
     CMP_INVALID_DICTSIZE = 1;
     CMP_INVALID_MODE     = 2;
     CMP_BAD_DATA         = 3;
     CMP_ABORT            = 4;

type
     TICallBack = function(var buffer; var size : Integer; var Param):Integer;cdecl;
     TOCallBack = procedure(var buffer; var size : Integer; var Param);cdecl;
     PTICallBack = ^TICallBack;
     PTOCallBack = ^TOCallBack;


     function implode( read_buff :TICallBack; write_buff :TOCallBack;
                      var work_buf, param ; var cmp_type, dsize : Integer):Integer;cdecl;

     function explode(read_buff :TICallBack; write_buff :TOCallBack;
                      var work_buf, param):Integer;cdecl;

     function crc32(var buffer; var size : Integer; var old_crc : Longint):Longint;cdecl;

implementation

     function implode(read_buff :TICallBack;  write_buff :TOCallBack;
                      var work_buf, param; var cmp_type, dsize : Integer):Integer;cdecl;
                      external 'impborl.dll' name '_implode';

     function explode(read_buff :TICallBack; write_buff :TOCallBack;
                      var work_buf, param):Integer;cdecl;
                      external 'impborl.dll' name '_explode';

     function crc32(var buffer; var size : Integer; var old_crc : Longint):Longint;cdecl;
                      external 'impborl.dll' name '_crc32';

end.
